// Windows Header Files:
#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <mmsystem.h>
#include <regstr.h>
#include <winreg.h>
#include <mmddk.h>

// Note that MODE and VERSION have been added for future rev's

enum COMMAND_IDS
{
	RESET = 1,
	VERSION,
	MODE,
	POLL
};

//
//   Function: ViOPoll( DWORD joyId, DWORD *Yaw, DWORD *Pitch, DWORD *Roll )
//
//   Purpose: Poll ViO headset if it is assigned as a joystick.
//

VOID	ViOPoll( DWORD joyId, DWORD *Roll, DWORD *Pitch, DWORD *Yaw )
{
JOYINFOEX	ViOinf;
MMRESULT	ret;

	ViOinf.dwSize  = sizeof( JOYINFOEX );
	ViOinf.dwReserved1 = 0;
	ViOinf.dwReserved2 = 0;				
	ViOinf.dwFlags = POLL;

	ret = joyGetPosEx( joyId, (LPJOYINFOEX)&ViOinf );
	if( !ret ) {										
		*Yaw   = ViOinf.dwX;
		*Pitch = ViOinf.dwY;
		*Roll  = ViOinf.dwZ;					
		}
	else {
		*Yaw   = 0;
		*Pitch = 0;
		*Roll  = 0;
		}
}	


//
//   FUNCTION: ViODeviceCk( DWORD joyId, LPBYTE str )
//
//   PURPOSE: Determine if the joystick id's device string contains <str>
//

UINT	ViODeviceCk( DWORD joyId, LPBYTE ChkStr )
{
UINT		cbjc, joyNum;
JOYCAPS		ViOcaps;
MMRESULT	result;


	joyNum = joyGetNumDevs();
	if( joyId >= joydev ) 
		return( 0 );
	else {
		cbjc = sizeof( JOYCAPS ); 
		result = joyGetDevCaps( JoyId, &pjc, cbjc );
		
		if( !result ) {
			GetStringFromRegistry( JoyId, ViOcaps.szRegKey, IdStr, STR_LEN );
			if( strstr( (const char *)IdStr, (const char *)ChkStr ) != NULL ) 
			   return(1); // Found ViO registry information
			}		
		}
	return( 0 );
}


//
//   Function: ViOReset( DWORD joyId )
//
//   Purpose: reset the Tracker
//

UINT	ViOReset ( DWORD	joyId )
{
JOYINFOEX	ViOinf;
MMRESULT	result;

	ViOinf.dwSize  = sizeof( JOYINFOEX );
	ViOinf.dwFlags = RESET;
	ViOinf.dwReserved1 = 0;
	ViOinf.dwReserved2 = 0;				
			
	result = joyGetPosEx( HMDId, (LPJOYINFOEX)&ViOinf );
	if( !result ) {
		ViOinf.dwFlags = RESET;
		result = joyGetPosEx( joyId, (LPJOYINFOEX)&ViOinf );
		}

	return result;	
}

//
//   Function: GetStringFromRegistry
//   
//   Purpose: returns TRUE if the string name passed is found and 
//			  registry of same name can be opened else returns FALSE. 
//
#define STR_LEN 256
BOOL GetStringFromRegistry(int id, char *regKey, unsigned char *string, int length)
{
	HKEY	hKey;
	int		returnVal;
	DWORD	valueType, valueSize;
	char registryKeyString[STR_LEN];
	char registryString[STR_LEN];

	sprintf(registryKeyString, REGSTR_PATH_JOYCONFIG "\\%s\\"REGSTR_KEY_JOYCURR, regKey);
	returnVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, registryKeyString, 0,KEY_QUERY_VALUE, &hKey);
	if ( returnVal != ERROR_SUCCESS ){
		return (FALSE);
		}

	sprintf(registryKeyString, REGSTR_VAL_JOYNOEMNAME, id+1);
	valueSize = sizeof(registryString);
	valueType = REG_SZ;
	returnVal = RegQueryValueEx(hKey, registryKeyString, NULL, 
				(LPDWORD)&valueType, (LPBYTE)registryString, &valueSize); 
	if ( returnVal == ERROR_SUCCESS ){
		RegCloseKey(hKey);
		sprintf(registryKeyString, REGSTR_PATH_JOYOEM "\\%s", registryString);
		returnVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, registryKeyString, 0,KEY_QUERY_VALUE, &hKey);
		if ( returnVal == ERROR_SUCCESS ){
			valueSize = sizeof(registryString);
			returnVal = RegQueryValueEx(hKey, REGSTR_VAL_JOYOEMNAME, NULL, 
					(LPDWORD)&valueType,(LPBYTE)registryString, &valueSize);
			if ( returnVal == ERROR_SUCCESS ){
// Now Verify registryString...				
				strcpy( (char *)string, (char *)registryString );
				}
			}
		}
	RegCloseKey(hKey);

	return ( (returnVal==ERROR_SUCCESS) ? TRUE : FALSE );
}
